/*
 * \brief  Trust Anchor common types
 * \author Jean-Adrien Domage
 * \date   2022-07-01
 */

#ifndef _TRUST_ANCHOR__TYPES_H_
#define _TRUST_ANCHOR__TYPES_H_

namespace Trust_anchor {


	namespace Services {
		constexpr static const char STATUS[]       = "status";
		constexpr static const char HASH_STORAGE[] = "hash_storage";
		constexpr static const char ENCRYPT[]      = "encrypt";
		constexpr static const char DECRYPT[]      = "decrypt";
	}

	enum class State: char {
		UNDEFINED = 0,
		UNINITIALIZED = 1,
		IDLE = 2,
		ERROR = 3,
		BUSY = 4,
		CLEAR_HASH = 5,
	};

	inline char const *state_to_string(State const &state) {
		switch (state) {
			case State::UNDEFINED:
				return "UNDEFINED";
			case State::UNINITIALIZED:
				return "UNINITIALIZED";
			case State::IDLE:
				return "IDLE";
			case State::ERROR:
				return "ERROR";
			case State::BUSY:
				return "BUSY";
			case State::CLEAR_HASH:
				return "CLEAR_HASH";
			default:
				return "";
		}
	}

}

#endif /* _TRUST_ANCHOR__TYPES_H_ */
